﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using WarfarinOnWeb.Code.BusinessLogic;
using WarfarinOnWeb.Code.DataAccess ;
using System.Collections.Generic;

namespace WarfarinOnWeb
{
    public partial class AttributeSelection : System.Web.UI.Page
    {
        DataOperation  dataOperation = new DataOperation();

        DataAccessHome dataAccess = new DataAccessHome();
        
        protected void Page_Load(object sender, EventArgs e)
        {
            string modelType = "";
            if (Request.QueryString["ModelType"] != null)
            {
                modelType = Request.QueryString["ModelType"].ToString();
            }
            else
            {
                modelType = "single";
            }
            Session["ModelType"] = modelType;
            //if (modelType == "single")
            //{
            //    pRepetingAttributes.Visible = false;
            //    lblTitleNo3.Text = "Selected Attributes";
            //}
            //if the call comes from the ModelList page
            if ( IsPostBack ==false)
            {
                Session["AttributeList"] = null;
                if (Request.QueryString["ModelID"] != null)
                {
                    int modelID = Convert.ToInt32(Request.QueryString["ModelID"]);
                    List<ModelAttribute> attributeList = dataAccess.GetAttributeList(modelID);
                    Session["AttributeList"] = attributeList;
                    GridViewBind();
                }
            }

        }

       protected void gvAttributes_RowDeleting(Object sender, GridViewDeleteEventArgs e)
        {
            List<ModelAttribute> attributeList = (List<ModelAttribute>)Session["AttributeList"];
            TableCell cellColumnName = gvAttributes.Rows[e.RowIndex].Cells[1];
            foreach (ModelAttribute att in attributeList)
            {
                //if (att.ColumnName == cellColumnName.Text && att.AttributeName == gvAttributes.Rows[e.RowIndex].Cells[2].Text &&
                //    att.Interval == int.Parse(gvAttributes.Rows[e.RowIndex].Cells[3].Text) && att.IsOutput == Convert.ToBoolean(gvAttributes.Rows[e.RowIndex].Cells[4].Text)) 
                    //&& att.NOofIntervals == int.Parse(gvAttributes.Rows[e.RowIndex].Cells[4].Text.Trim()))
                if ( att.AttributeName == gvAttributes.Rows[e.RowIndex].Cells[2].Text )
                {
                    attributeList.Remove(att);
                    Session["AttributeList"] = attributeList;
                    GridViewBind();
                    break;
                }
            }
        }
      

        protected void btnAddCalculatedAttribute_Click(object sender, EventArgs e)
        {
            string attributeName = "";
            List<ModelAttribute> attributeList;
            ModelAttribute attribute = null;
            int intervalLen = 0;
            //calculate how many days is interval,0 days means total
            if (ddlInterval.SelectedValue == "0")
                intervalLen = 0;
            else
             intervalLen = int.Parse(ddlInterval.SelectedValue) * int.Parse(txtIntervalCount.Text);
            attributeName = MakeAttributeName();
            attribute = new ModelAttribute(rbtColumnNames.SelectedItem.Text.Trim(),attributeName.Trim() , rbtFunctions.SelectedValue.Trim(), intervalLen, ckbIsOutput1.Checked);
            
            if(Session["AttributeList"]!=null)
                 attributeList = (List<ModelAttribute>)Session["AttributeList"];
            else
                 attributeList= new List<ModelAttribute>();
            attributeList.Add(attribute);
            Session["AttributeList"] = attributeList;
            GridViewBind();
        }
        protected string MakeAttributeName()
        {
            string attributeName = "";
            if (rbtFunctions.SelectedValue.ToLower() != "none")
            {
                string interval = (ddlInterval.SelectedValue == "0") ? "tot" : txtIntervalCount.Text + "day";
                attributeName = rbtFunctions.SelectedValue.Trim().ToLower() +
                    rbtColumnNames.SelectedItem.Text.Trim() + interval.Trim();
            }
            else
            {
                attributeName = rbtColumnNames.SelectedItem.Text.Trim();
            }
            return attributeName;
        }
        protected void GridViewBind()
        {
            gvAttributes.DataSource = (List<ModelAttribute>)Session["AttributeList"];
            gvAttributes.DataBind();
            
        }

        protected void btnAddGeneralAttribute_Click(object sender, EventArgs e)
        {
            List<ModelAttribute> attributeList;
            ModelAttribute attribute = null;
            if (Session["AttributeList"] != null)
                attributeList = (List<ModelAttribute>)Session["AttributeList"];
            else
                attributeList = new List<ModelAttribute>();
            foreach (ListItem item in ckbList.Items)
            {
                if (item.Selected == true)
                {
                    attribute = new ModelAttribute(item.Text.Trim(),item.Text.Trim(), "none",0,ckbIsOutput2.Checked);
                    attributeList.Add(attribute);
                    //reset them to be not selected
                    item.Selected = false;

                    
                }
            }
            //reset output checkbox
            ckbIsOutput2.Checked = false;
            Session["AttributeList"] = attributeList;
            GridViewBind();
        }
        protected void RepeateCheckedAttributes()
        {
            List<ModelAttribute> attributeList;
           // int newStartIndex = 0;
            attributeList = (List<ModelAttribute>)Session["AttributeList"];
            for (int i = 1; i < int.Parse(ddlNoLastReadings.SelectedValue); i++)
            {
                foreach (GridViewRow gvr in gvAttributes.Rows)
                {
                    CheckBox ckBox = (CheckBox)gvr.FindControl("RowLevelCheckBox");

                    if (ckBox.Checked)
                    {

                        // newStartIndex = newStartIndex  + int.Parse(gvr.Cells[4].Text);
                        string attributeName = "prev" + i.ToString() + gvr.Cells[2].Text;

                        ModelAttribute attribute = new ModelAttribute(gvr.Cells[1].Text.Trim(), attributeName.Trim(), gvr.Cells[3].Text.Trim(), int.Parse(gvr.Cells[4].Text), false);
                        attributeList.Add(attribute);
                    }
                }
            }
            Session["AttributeList"] = attributeList;
            GridViewBind();


            
        }
        public bool OutputColumnExists()
        {
            bool result = false;
            int count = 0;
            List<ModelAttribute> attributeList;
            attributeList = (List<ModelAttribute>)Session["AttributeList"];
            foreach (ModelAttribute ma in attributeList)
            {
                if (ma.IsOutput == true)
                {
                    result = true;
                    count++;
                }
                
            }
            if (result == true && count == 1)
            {
                return true;
            }
            else
            {
                return false;
            }


        }
        protected void btnModel_Click(object sender, EventArgs e)
        {
            bool result = false;
            //RepeateCheckedAttributes();
            if (!OutputColumnExists())
            {
                lblErrorMsg.Text = " **** One  column (but only one) has to be marked as Output column.";

            }
            else
            {
                ArrayList algorithms = GetAlgorithmsSelected();
                if (algorithms.Count == 0)
                    lblErrorMsg.Text = " **** You must select at least on Algorithm to build a model with.";
                else
                {
                    lblErrorMsg.Text = "";
                    ModelBuilder mb = new ModelBuilder();
                    result=mb.CreateModel((int)Session["PatientID"], (int)Session["PersonID"], Session["ModelType"].ToString(), (List<ModelAttribute>)Session["AttributeList"],algorithms);
                }
            }
            if (result == true)
            {
                Label1.Visible = true;
                Label1.Text = "Models were succesfuly created";
            }
            else
            {
                Label1.Text = "There was a problem in creating models";
            }
            Panel1.Visible = false;
            Panel2.Visible = true;

        }
        protected ArrayList  GetAlgorithmsSelected()
        {
            ArrayList algorithms = new ArrayList();
            foreach (ListItem l in ckAlgorithms.Items)
            {
                if (l.Selected)
                    algorithms.Add(l.Value);
            }
            return algorithms;
        }
        protected void btnAddRepeatingAttributes_Click(object sender, EventArgs e)
        {
            RepeateCheckedAttributes();
        }

        

       
    }
}
