﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using System.Web.Hosting;
using WarfarinOnWeb.Code.DataAccess;
using System.Diagnostics;


namespace WarfarinOnWeb.Code.BusinessLogic
{
    public class ModelBuilder
    {
        //private int modelID=0;
        //private string modelType;
        //private int patientID;
        //private List<ModelAttribute> attributeList;
        //private int noLastReadings;
        //private DataTable attColumnDetails;
       // private string arffData;
        private string modelDirectoryPath = HostingEnvironment.ApplicationPhysicalPath + "App_Data\\Model\\";
        private string arffFilePath = HostingEnvironment.ApplicationPhysicalPath +"App_Data\\Test.arff";
        
        
        //private int createdBy;
        //private string modelFileName;
        
       


        public ModelBuilder()
        {

        }

        public bool CreateModel(int patientID, int createdBy, string modelType, List<ModelAttribute> attributeList,  ArrayList algorithms)
        {
            bool result = false;
            try
            {
                DataAccessHome dataAccess = new DataAccessHome();
                Model model =dataAccess.CreateModelObject(patientID, createdBy, "", modelType);
                DataPointGenerator datapointG = new DataPointGenerator(model, attributeList);
                string arffFilePath = datapointG.GenerateData();
                WekaUtil wekaU = new WekaUtil();
                foreach (string algorithm in algorithms)
                {
                    model.Algorithm = algorithm;
                    model.ModelFileName = wekaU.GenerateModelFromArffFile(arffFilePath, model.Algorithm);
                    model.AccuracyLevel = wekaU.GetAccuracyLevel(arffFilePath, model.Algorithm);
                    FileInfo f = new FileInfo(modelDirectoryPath+model.ModelFileName);
                    if(f.Exists)
                    dataAccess.InsertNewModel(model, attributeList);
                }
                result = true;
            }
            catch(Exception e)
            {
                Debug.Write(e.Message);
                result = false;
            }
            return result;
        }

        public void UpdateModel(int modelID)
        {
            try
            {
                DataAccessHome dataAccess = new DataAccessHome();
                Model model = dataAccess.GetModel(modelID);
                List<ModelAttribute> attributeList = dataAccess.GetAttributeList(modelID);
                DataPointGenerator datapointG = new DataPointGenerator(model, attributeList);
                string arffFilePath = datapointG.GenerateData();
                WekaUtil wekaU = new WekaUtil();
                wekaU.UpdateModel(model.ModelFileName, arffFilePath, model.Algorithm);
                model.AccuracyLevel = wekaU.GetAccuracyLevel(arffFilePath, model.Algorithm);
                dataAccess.UpdateModel(model.ModelID, model.AccuracyLevel);
            }
            catch (Exception e)
            {
                Debug.Write(e.Message);
            }


        }
        //public void UpdateModel(int modelID, float accuracyLevel)
        //{
        //    DataAccessHome dataAccess = new DataAccessHome();
        //    dataAccess.UpdateModel(

        //}
    
   

        

    }
}
