﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using weka.core;
using weka.classifiers;
using weka.experiment;
using weka.classifiers.trees;
using java.util;
using System.IO;
using System.Web.Hosting;

namespace WarfarinOnWeb.Code.BusinessLogic
{
    public class WekaUtil
    {
        //get this from web config
        private string modelDirectoryPath = HostingEnvironment.ApplicationPhysicalPath + "App_Data\\Model\\";
        private string logFile = HostingEnvironment.ApplicationPhysicalPath + "App_Data\\Log.txt";
        //private System.Collections.ArrayList algorithms;
        const int percentSplit = 66;

        public string GenerateModelFromArffFile(string arffFilePath, string algorithm)
        {
            string modelName = "";
            int modelFileNo = 0;
            List v = null;
            float accuracyLevel;
            try
            {
                //latest model number file wise that will be used as addon for the file name for each model created below
                modelFileNo = GetLastModelNoFromFileName();

                weka.core.Instances insts = new weka.core.Instances(new java.io.FileReader(arffFilePath));
                insts.setClassIndex(insts.numAttributes() - 1);

               
                weka.classifiers.Classifier cl;
               // foreach (string algName in algorithms)
                //{
                if (algorithm == "smo")
                    {
                        try
                        {
                            //cl = new weka.classifiers.functions.SMO();
                            //cl.buildClassifier(train);
                            //accuracyLevel = GetAccuracyLevel(insts, cl);
                            cl = new weka.classifiers.functions.SMO();
                            v = BuildClassifier(cl, insts);
                            
                                modelName =  "SMOModel" + modelFileNo.ToString();
                                SerializationHelper.write(modelDirectoryPath + modelName, v);
                              //  InsertModelInToDatabase("smo", "SMOModel" + modelFileNo.ToString(), accuracyLevel);
                           
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "smoreg")
                    {
                        try
                        {
                            
                            cl = new weka.classifiers.functions.SMOreg();
                            v = BuildClassifier(cl, insts);
                            
                                modelName =  "SMOregModel" + modelFileNo.ToString();
                                SerializationHelper.write(modelDirectoryPath + modelName, v);
                               // InsertModelInToDatabase("smoreg", "SMOregModel" + modelFileNo.ToString(), accuracyLevel);
                            
                            
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "j48")
                    {
                        try
                        {
                            
                            cl = new J48();
                            v = BuildClassifier(cl, insts);
                           
                                modelName = "J48Model" + modelFileNo.ToString();
                                SerializationHelper.write(modelDirectoryPath + modelName, v);
                               // InsertModelInToDatabase("j48", "J48Model" + modelFileNo.ToString(), accuracyLevel);
                           
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "nnge")
                    {
                        try
                        {
                            
                            cl = new weka.classifiers.rules.NNge();
                            v = BuildClassifier(cl, insts);
                            
                                modelName =  "NNgeModel" + modelFileNo.ToString();
                                SerializationHelper.write(modelDirectoryPath + modelName, v);
                               // InsertModelInToDatabase("nnge", "NNgeModel" + modelFileNo.ToString(), accuracyLevel);
                           
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "flr")
                    {
                        try
                        {

                            
                            cl = new weka.classifiers.misc.FLR();
                            //build final model with all instances
                            v = BuildClassifier(cl, insts);
                            
                                modelName =  "FLRModel" + modelFileNo.ToString();
                                SerializationHelper.write(modelDirectoryPath + modelName, v);
                                //InsertModelInToDatabase("flr", "FLRModel" + modelFileNo.ToString(), accuracyLevel);
                            
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "ibk")
                    {
                        try
                        {
                            //cl = new weka.classifiers.lazy.IBk();
                            //cl.buildClassifier(train);
                            //accuracyLevel = GetAccuracyLevel(insts, cl);
                            cl = new weka.classifiers.lazy.IBk();
                            v = BuildClassifier(cl, insts);
                            
                                modelName = "IBkModel" + modelFileNo.ToString();
                                SerializationHelper.write(modelDirectoryPath + modelName, v);
                             //   InsertModelInToDatabase("ibk", "IBkModel" + modelFileNo.ToString(), accuracyLevel);
                           
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }
                }



            //}
            catch (java.lang.Exception ex)
            {

                weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
            }
            return modelName;


        }
        public void UpdateModel(string modelFileName, string arffFilePath, string algorithm)
        {
                
           
            List v = null;
            float accuracyLevel;
            try
            {
   
                weka.core.Instances insts = new weka.core.Instances(new java.io.FileReader(arffFilePath));
                insts.setClassIndex(insts.numAttributes() - 1);

                ////randomize the order of the instances in the dataset.
                //weka.filters.Filter myRandom = new weka.filters.unsupervised.instance.Randomize();
                //myRandom.setInputFormat(insts);
                //insts = weka.filters.Filter.useFilter(insts, myRandom);

                //int trainSize = insts.numInstances() * percentSplit / 100;
                //int testSize = insts.numInstances() - trainSize;
               // weka.core.Instances train = new weka.core.Instances(insts, 0, trainSize);
                weka.classifiers.Classifier cl;
               // foreach (string algName in algorithms)
                //{
                if (algorithm == "smo")
                    {
                        try
                        {
                            
                            cl = new weka.classifiers.functions.SMO();
                            v = BuildClassifier(cl, insts);
                           
                                FileInfo f = new FileInfo(modelDirectoryPath + modelFileName);
                                f.Delete();

                                SerializationHelper.write(modelDirectoryPath + modelFileName, v);
                            
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "smoreg")
                    {
                        try
                        {
                            
                            cl = new weka.classifiers.functions.SMOreg();
                            v = BuildClassifier(cl, insts);
                           
                                FileInfo f = new FileInfo(modelDirectoryPath + modelFileName);
                                f.Delete();
                                SerializationHelper.write(modelDirectoryPath + modelFileName, v);
                               
                           
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "j48")
                    {
                        try
                        {
                            
                            cl = new J48();
                            v = BuildClassifier(cl, insts);
                            
                                FileInfo f = new FileInfo(modelDirectoryPath + modelFileName);
                                f.Delete();
                                SerializationHelper.write(modelDirectoryPath + modelFileName, v);
                             
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "nnge")
                    {
                        try
                        {
                            
                            cl = new weka.classifiers.rules.NNge();
                            v = BuildClassifier(cl, insts);
                           
                                FileInfo f = new FileInfo(modelDirectoryPath + modelFileName);
                                f.Delete();
                                SerializationHelper.write(modelDirectoryPath + modelFileName, v);
                             
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "flr")
                    {
                        try
                        {

                           
                            cl = new weka.classifiers.misc.FLR();
                            //build final model with all instances
                            v = BuildClassifier(cl, insts);
                            
                                FileInfo f = new FileInfo(modelDirectoryPath +  modelFileName);
                                f.Delete();
                                SerializationHelper.write(modelDirectoryPath + modelFileName, v);
                              
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }

                if (algorithm == "ibk")
                    {
                        try
                        {
                           
                            cl = new weka.classifiers.lazy.IBk();
                            v = BuildClassifier(cl, insts);
                            
                                FileInfo f = new FileInfo(modelDirectoryPath +  modelFileName);
                                f.Delete();
                                SerializationHelper.write(modelDirectoryPath + modelFileName, v);
                             
                        }
                        catch (java.lang.Exception ex)
                        {
                            weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
                        }
                    }
                }



            //}
            catch (java.lang.Exception ex)
            {

                weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
            }
            


        }

        

        public float GetAccuracyLevel(string arffFilePath,string algorithm)
        {
    
            float result = 0f;
            weka.core.Instances insts = new weka.core.Instances(new java.io.FileReader(arffFilePath));
            insts.setClassIndex(insts.numAttributes() - 1);

            //randomize the order of the instances in the dataset.
            weka.filters.Filter myRandom = new weka.filters.unsupervised.instance.Randomize();
            myRandom.setInputFormat(insts);
            insts = weka.filters.Filter.useFilter(insts, myRandom);

            int trainSize = insts.numInstances() * percentSplit / 100;
            int testSize = insts.numInstances() - trainSize;
            weka.core.Instances train = new weka.core.Instances(insts, 0, trainSize);
            weka.classifiers.Classifier cl;

            switch (algorithm)
            {
                case "smo":
                     cl = new weka.classifiers.functions.SMO();
                    break;
                case "smoreg":
                    cl = new weka.classifiers.functions.SMOreg();
                    break;
                case "j48":
                    cl = new J48();
                    break;
                case "nnge":
                    cl = new weka.classifiers.rules.NNge();
                    break;
                case "flr":
                    cl = new weka.classifiers.misc.FLR();
                    break;
                case "ibk":
                    cl = new weka.classifiers.lazy.IBk();
                    break;
                default:
                    cl = new weka.classifiers.lazy.IBk();
                break;

            }
            try
            {
                cl.buildClassifier(train);
                int numCorrect = 0;
                for (int i = trainSize; i < insts.numInstances(); i++)
                {
                    weka.core.Instance currentInst = insts.instance(i);
                    double predictedClass = cl.classifyInstance(currentInst);
                    if (predictedClass == insts.instance(i).classValue())
                        numCorrect++;

                }


                result= (float)((float)numCorrect / (float)testSize * 100.0);
            }
            catch (java.lang.Exception ex)
            {

                weka.core.Debug.writeToFile(logFile, DateTime.Now + " " + ex);
            }

            return result;
        }


       

        private ArrayList BuildClassifier(weka.classifiers.Classifier cl, weka.core.Instances insts)
        {

            cl.buildClassifier(insts);

            //save model + header
            ArrayList v = new ArrayList();
            v.add(cl);
            v.add(new Instances(insts, 0));
            return v;
        }
        public int GetLastModelNoFromFileName()
        {
            string modelNumber = "";
            int result = 0;
            DirectoryInfo d = new DirectoryInfo(modelDirectoryPath);
            if (d.Exists)
            {
                foreach (FileInfo f in d.GetFiles("*Model*"))
                {
                    modelNumber = f.Name.Substring(f.Name.IndexOf("Model") + 5, f.Name.Length - (f.Name.IndexOf("Model") + 5));
                    if (int.Parse(modelNumber) > result)
                    {
                        result = int.Parse(modelNumber);
                    }
                }
            }
            else
            {
                d.Create();
            }

            return result + 1;
        }

        public double Predict(string arffFilePath,string modelFileName)
        {
            weka.core.Instances insts = new weka.core.Instances(new java.io.FileReader(arffFilePath));
            insts.setClassIndex(insts.numAttributes() - 1);
            //read model and header
            java.util.ArrayList v = (java.util.ArrayList)SerializationHelper.read(modelDirectoryPath + modelFileName);
            Classifier cl = (Classifier)v.get(0);
            Instances header = (Instances)v.get(1);

            //one and only instance
            Instance curr = insts.instance(0);
            Instance inst = new Instance(header.numAttributes());
            inst.setDataset(header);

            for (int n = 0; n < header.numAttributes(); n++)
            {
                weka.core.Attribute att = insts.attribute(header.attribute(n).name());
                if (att != null)
                {
                    if (att.isNominal())
                    {
                        if ((header.attribute(n).numValues() > 0) && (att.numValues() > 0))
                        {

                            string label = curr.stringValue(att);
                            int index = header.attribute(n).indexOfValue(label);
                            if (index != -1)
                                inst.setValue(n, index);

                        }
                    }
                    else if (att.isNumeric())
                    {
                        inst.setValue(n, curr.value(att));
                    }
                    else
                    {
                        throw new Exception("Unhandled attribute type!");
                    }
                }
            }


          

            double pred = cl.classifyInstance(curr);
            return pred;

        }

        
    }
}
