﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.Collections;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Web.Hosting;
using System.Diagnostics;


namespace WarfarinOnWeb.Code.DataAccess
{
    //place where I will be getting data from database 
    public class DataAccessHome
    {

        public string GetPassword(string userCode)
        {
            string password = "";
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetPassword", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("UserCode", userCode));
                    SqlTransaction t = conx.BeginTransaction();
                            cmd.Transaction = t;
                            try
                            {
                                password = (string)cmd.ExecuteScalar();


                                t.Commit();
                       
                            }
                            catch(SqlException e)
                            {
                                t.Rollback();
                                Debug.WriteLine(e.Message);
                            }
                            
                }

            }
            return password;
            
        }
        
        //odmah napuni objekat
        public User  GetUser(string userCode)
        {
            SqlDataReader reader = null;
            //DataSet ds = new DataSet();
            User user = new User();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetPerson", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("UserCode", userCode));
                   SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                          
                            try
                            {
                                reader = cmd.ExecuteReader();
                                reader.Read();
                                user.PersonID = reader.GetInt32(0);
                                user.FirstName = reader.GetString(1);
                                user.SurName = reader.GetString(2);
                                user.Type = reader.GetString(3);
                                user.UserCode = userCode;
                                //ds.Load(reader, LoadOption.OverwriteChanges, "UserDataTable");
                               
                                
                            }
                            catch(SqlException e)
                            {
                               t.Rollback();
                                Debug.WriteLine(e.Message);
                            }
                            finally
                            {
                                reader.Close();
                                reader.Dispose();
                                t.Commit();
                            }
                }

            }
         
            return user;
            
        }

        public List<Patient>  GetPatientList(int personID,string toMake)
        {
            List<Patient> patientList = new List<Patient>();
            SqlDataReader reader = null;
            int modelCount = 0;
            if (toMake == "prediction")
                modelCount = 1;
            else
                modelCount = 0;

            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetPatientListByPerson", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PersonID", personID));
                    cmd.Parameters.Add(new SqlParameter("ModelCount", modelCount));
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                         reader = cmd.ExecuteReader();
                         
                         //ds.Load(reader, LoadOption.OverwriteChanges, "PatientTable");
                         while (reader.Read())
                         {
                             Patient patient = new Patient();
                             patient.PatientID = reader.GetInt32(0);
                             patient.FullName = reader.GetString(1) + ' ' + reader.GetString(2);
                             patient.Gender = reader.GetString(3);
                             patient.DOB = reader.GetDateTime(4);
                             patient.TargetINRLow = (float)reader.GetDouble(5);
                             patient.TargetINRHigh = (float)reader.GetDouble(6);
                             patient.DateOfOperation = reader.GetDateTime(7);
                             patient.ValveType = reader.GetString(8);
                             patientList.Add(patient);
                         }

                         


                    }
                    catch (OleDbException e)
                    {
                        t.Rollback();
                        Debug.WriteLine(e.Message);
                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }
                }

            }
            //return ds.Tables[0];
            return patientList;
        }

        
        //ovo treba da ostane kao datatable a napravi jos jednu takvu gde ce da se vrati DoseList
        public DataTable   GetDoseTable(int patientID)
        {
            SqlDataReader reader = null;
            DataSet ds = new DataSet();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetDosesByPatient", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                         reader = cmd.ExecuteReader();
                         ds.Load(reader, LoadOption.OverwriteChanges, "DoseTable");
                        
                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }

                    
                }
            }
            return ds.Tables[0];

        }


        public List<Dose> GetDoseList(int patientID)
        {
            SqlDataReader reader = null;
            List<Dose> doseList = new List<Dose>();
            //DataSet ds = new DataSet();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetDosesByPatient", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                        //ds.Load(reader, LoadOption.OverwriteChanges, "DoseTable");
                        while (reader.Read())
                        {
                            Dose dose = new Dose();
                            dose.PatientID = reader.GetInt32(0);
                            dose.ReadingDate = reader.GetDateTime(1);
                            dose.INR = (float)reader.GetDouble(2);
                            dose.NINR =reader.GetString(3);
                            if (!(Convert.IsDBNull(reader[4]))) dose.Day1 = (float)reader.GetDouble(4);
                            if (!(Convert.IsDBNull(reader[5]))) dose.Day2 = (float)reader.GetDouble(5);
                            if (!(Convert.IsDBNull(reader[6]))) dose.Day3 = (float)reader.GetDouble(6);
                            if (!(Convert.IsDBNull(reader[7]))) dose.Day4 = (float)reader.GetDouble(7);
                            if (!(Convert.IsDBNull(reader[8]))) dose.Day5 = (float)reader.GetDouble(8);
                            if (!(Convert.IsDBNull(reader[9]))) dose.Day6 = (float)reader.GetDouble(9);
                            if (!(Convert.IsDBNull(reader[10]))) dose.Day7 = (float)reader.GetDouble(10);
                            doseList.Add(dose);
                        }
                        
                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            //return ds.Tables[0];
            return doseList;

        }

        public DataTable GetAttributeColumns()
        {
            DataTable table = null;
            //string myXMLfile = @"|DataDirectory|\AttributeColumns.xml";
            string myXMLfile = HostingEnvironment.ApplicationPhysicalPath + "App_Data\\AttributeColumns.xml";
            DataSet ds = new DataSet();
            // Create new FileStream with which to read the schema.
            System.IO.FileStream fsReadXml = new System.IO.FileStream
                (myXMLfile, System.IO.FileMode.Open);
            try
            {
                ds.ReadXml(fsReadXml);
                table = ds.Tables[0];
                //foreach (DataRow dr in table.Rows)
                //{
                //    Debug.Write(dr[0]);
                //}
                
            }
            catch (Exception ex)
            {
                Debug.Write(ex.ToString());
            }
            finally
            {
                fsReadXml.Close();
            }
            return table;

        }
        public DataTable GetAttributeColumns(string applyFunction, string usedByModelType)
        {
            bool deleted = false;
            DataTable dt = null;
            //this should be in web.config
            string myXMLfile = HostingEnvironment.ApplicationPhysicalPath + "App_Data\\AttributeColumns.xml";
            DataSet ds = new DataSet();
            // Create new FileStream with which to read the schema.
            System.IO.FileStream fsReadXml = new System.IO.FileStream
                (myXMLfile, System.IO.FileMode.Open);
            try
            {
                ds.ReadXml(fsReadXml);
                dt = ds.Tables[0];
                for (int i = 0; i < dt.Rows.Count; i++)
                {

                    if (i == 1 && deleted == true)
                    {
                        i--;
                        deleted = false;
                    }
                    DataRow dr = dt.Rows[i];
                    //remove rows that are not having the appropriate applyfunction and UsedBYBmodelTYpe values
                    if (dr["ApplyFunction"].ToString().Trim().ToLower() != applyFunction ||
                        (dr["UsedByModelType"].ToString().Trim().ToLower() != "all" && dr["UsedByModelType"].ToString().Trim().ToLower() != usedByModelType))
                    {
                        dt.Rows[i].Delete();
                        if (i != 0)
                            i--;
                        deleted = true;

                    }
                }
                return dt;

            }
            catch (Exception ex)
            {
                Debug.Write(ex.ToString());
            }
            finally
            {
                fsReadXml.Close();
            }
            return dt;

        }
        //HASN'T BEEN USED
        //privious no of previous dosages for chosen patient
        public DataTable GetDoseTable(int patientID, int noLastReadings)
        {
            SqlDataReader reader = null;
            DataSet ds = new DataSet();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetDosesByPatientAndNoLastReadings", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                    cmd.Parameters.Add(new SqlParameter("NoLastReadings", noLastReadings));
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                        ds.Load(reader, LoadOption.OverwriteChanges, "DoseTable");
                        

                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            return ds.Tables[0];

        }

       

        public List<int> PatientList()
        {

            SqlDataReader reader = null;
            List<int> PatientDoseCount = new List<int>();

            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("PatientDoseCount", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;

                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            PatientDoseCount.Add(reader.GetInt32(0));

                        }


                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            return PatientDoseCount;

        }
        //make this return the list of attributes
        public List<ModelAttribute> GetAttributeList(int modelID)
        {
            List<ModelAttribute> attributeList = new List<ModelAttribute>();
            SqlDataReader reader = null;
            //DataSet ds = new DataSet();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetAttributeList", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("ModelID", modelID));
                    
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            ModelAttribute ma = new ModelAttribute(reader.GetString(0), reader.GetString(1), reader.GetString(2),reader.GetInt32(3), reader.GetBoolean(4));
                            attributeList.Add(ma);  
                            
                        }
                        //ds.Load(reader, LoadOption.OverwriteChanges, "AttributeTable");
                        

                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            //return ds.Tables[0];
            return attributeList;

        }

        public int InsertNewModel(Model model,List<ModelAttribute> attributeList)
        {
            int modelID = 0;
            
            SqlTransaction t;

            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("InsertModel", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", model.PatientID));                   
                    cmd.Parameters.Add(new SqlParameter("MadeByPerson", model.CreatedBy ));
                    cmd.Parameters.Add(new SqlParameter("ModelFileName", model.ModelFileName ));
                    cmd.Parameters.Add(new SqlParameter("ModelType", model.ModelType ));
                    cmd.Parameters.Add(new SqlParameter("Algorithm", model.Algorithm ));
                    cmd.Parameters.Add(new SqlParameter("AccuracyLevel", model.AccuracyLevel));
                    t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        modelID = Convert.ToInt32(cmd.ExecuteScalar());

                       

                    }
                    catch (SqlException e)
                    {
                        t.Rollback();
                        Debug.Write(e.Message);

                    }



                }
                foreach (ModelAttribute ma in attributeList)
                {

                    using (SqlCommand cmd = new SqlCommand("InsertAttribute", conx))
                    {
                        cmd.CommandType = CommandType.StoredProcedure;
                        cmd.Parameters.Add(new SqlParameter("ModelID",modelID));
                        cmd.Parameters.Add(new SqlParameter("ColumnName",ma.ColumnName));
                        cmd.Parameters.Add(new SqlParameter("AttributeName",ma.AttributeName ));
                        cmd.Parameters.Add(new SqlParameter("FunctionName",ma.Function ));
                        cmd.Parameters.Add(new SqlParameter("Interval", ma.Interval));
                        cmd.Parameters.Add(new SqlParameter("IsOutput", ma.IsOutput));
                        cmd.Transaction = t;
                        try
                        {
                            cmd.ExecuteNonQuery();

                        }
                        catch (SqlException e)
                        {
                            t.Rollback();
                            Debug.Write(e.Message);

                        }



                    }
                }

                t.Commit();


            }
            return modelID;
        }
        //make it populate model object
        public List<Model> GetModelList(int patientID)
        {
            SqlDataReader reader = null;
            //DataSet ds = new DataSet();
            List<Model> modelList = new List<Model>();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetModelList", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                    
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            Model model = new Model();
                            model.ModelID = reader.GetInt32(0);
                            model.PatientID = reader.GetInt32(1);
                            model.CreatedBy = reader.GetInt32(4);
                            model.DateCreated = reader.GetDateTime(6);
                            if (!(Convert.IsDBNull(reader[7]))) model.DateUpdated = reader.GetDateTime(7);
                            model.ModelFileName = reader.GetString(8);
                            model.ModelType = reader.GetString(9);
                            model.Algorithm = reader.GetString(10);
                            model.AccuracyLevel = (float)reader.GetDouble(11);
                            model.UseInPrediction = reader.GetBoolean(12);
                            modelList.Add(model);
                        }
                        //ds.Load(reader, LoadOption.OverwriteChanges, "ModelTable");
                        

                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            return modelList;

        }

        public DataTable GetModelTable(int patientID)
        {
            SqlDataReader reader = null;
            DataSet ds = new DataSet();
           // List<Model> modelList = new List<Model>();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetModelList", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));

                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                       
                        ds.Load(reader, LoadOption.OverwriteChanges, "ModelTable");


                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            return ds.Tables[0]; ;

        }

        //get it to populate model object
        public Model GetModel(int modelID)
        {
            SqlDataReader reader = null;
            Model model = new Model();
           // DataSet ds = new DataSet();
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("GetModel", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("ModelID", modelID));

                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        reader = cmd.ExecuteReader();
                        reader.Read();
                        model.ModelID = reader.GetInt32(0);
                        model.PatientID = reader.GetInt32(1);
                        model.CreatedBy = reader.GetInt32(2);
                        model.DateCreated = reader.GetDateTime(3);
                        if (!(Convert.IsDBNull(reader[4]))) model.DateUpdated = reader.GetDateTime(4);
                        model.ModelFileName = reader.GetString(5);
                        model.ModelType = reader.GetString(6);
                        model.Algorithm = reader.GetString(7);
                        model.AccuracyLevel = (float)reader.GetDouble(8);
                        model.UseInPrediction = reader.GetBoolean(9);
                        //ds.Load(reader, LoadOption.OverwriteChanges, "ModelTable");
                        

                    }
                    catch (SqlException e)
                    {
                        Debug.Write(e.Message);
                        t.Rollback();

                    }
                    finally
                    {
                        reader.Close();
                        reader.Dispose();
                        t.Commit();
                    }


                }
            }
            return model;

        }
        public int InsertOrUpdateReading(int patientID, float inr, int period)
        {
            int result=0;
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("InsertReading", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                    cmd.Parameters.Add(new SqlParameter("Inr", inr));
                    cmd.Parameters.Add(new SqlParameter("Period", period));
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        result =cmd.ExecuteNonQuery();
                        t.Commit();
                    }
                    catch (SqlException ex)
                    {
                        Debug.Write(ex.Message);
                        t.Rollback();
                    }
                }
            }
            return result;
        }
        public void UpdateModel(int modelID, float accuracyLevel)
        {

            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                using (SqlCommand cmd = new SqlCommand("UpdateModel", conx))
                {
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Add(new SqlParameter("ModelID", modelID));
                    cmd.Parameters.Add(new SqlParameter("AccuracyLevel", accuracyLevel));
                    SqlTransaction t = conx.BeginTransaction();
                    cmd.Transaction = t;
                    try
                    {
                        cmd.ExecuteNonQuery();
                        t.Commit();
                    }
                    catch (SqlException ex)
                    {
                        Debug.Write(ex.Message);
                        t.Rollback();
                    }
                }
            }
        }

        public void FlagModelToUseInPrediction(int patientID,ArrayList modelIdList)
        {
           
            using (SqlConnection conx = new SqlConnection(ConfigurationManager.ConnectionStrings["WarfarinSqlServer"].ConnectionString))
            {
                conx.Open();
                SqlTransaction t = conx.BeginTransaction();
                //mark all of them not to be used in prediction, and then flag once from the list as the ones to be used.
                using (SqlCommand cmd = new SqlCommand("Update Model set UseInPrediction=0 where PatientId=@PatientID", conx))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                    cmd.Transaction =t;

                    try
                        {

                            cmd.ExecuteNonQuery();
                           

                        }
                        catch (SqlException ex)
                        {
                            Debug.Write(ex.Message);
                            t.Rollback();
                        }

                }
                foreach (int i in modelIdList)
                {

                    using (SqlCommand cmd = new SqlCommand("UpdateUseInPrediction", conx))
                    {
                        cmd.CommandType = CommandType.StoredProcedure;
                        cmd.Parameters.Add(new SqlParameter("modelID", i));
                        cmd.Parameters.Add(new SqlParameter("PatientID", patientID));
                        
                        cmd.Transaction = t;
                        try
                        {

                            cmd.ExecuteNonQuery();
                           

                        }
                        catch (SqlException ex)
                        {
                            Debug.Write(ex.Message);
                            t.Rollback();
                        }
                        
                    }
                }
                t.Commit();
            }

        }

        public Model CreateModelObject(int patientID, int createdBy, string modelFileName, string modelType)
        {
            Model model = new Model();
            model.PatientID = patientID;
            model.CreatedBy = createdBy;
            model.ModelFileName = modelFileName;
            model.ModelType = modelType;
            //model.Algorithm = algorithm;
           // model.AccuracyLevel = accuracyLevel;
            return model;

        }

    }
}
