﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using WarfarinOnWeb.Code.BusinessLogic;
using WarfarinOnWeb.Code.DataAccess;

namespace WarfarinOnWeb
{
    public partial class MakePrediction : System.Web.UI.Page
    {
        
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["User"] == null)
            {
                Response.Redirect("./Login.aspx");
            }
            if(Request.QueryString["PatientID"]!=null)
            {
            int patientID = int.Parse(Request.QueryString["PatientID"].ToString());
            Session["PatientID"] = patientID;
            }
           
            
            if (!IsPostBack)
            {
                if (Request.QueryString["PatientName"] != null)
                {
                    lblSelectModel.Text = lblSelectModel.Text + " for " + Request.QueryString["PatientName"].ToString();

                }
                //select the attributes of the first model
                ClientScript.GetPostBackClientHyperlink(gvModelList, "Select$" + 0);
                gdvAttributeList.DataBind();

            }
        }

       

        protected void btnAddNewReading_Click(object sender, EventArgs e)
        {
            DataAccessHome dataAccess = new DataAccessHome();
            ModelBuilder mb = new ModelBuilder();
            ArrayList modelList = new ArrayList();
            foreach(GridViewRow gvr in gvModelList.Rows)
            {
                CheckBox ckBox = (CheckBox)gvr.FindControl("ModelCheckBox");
                if (ckBox.Checked)
                {
                    modelList.Add(Convert.ToInt32(gvModelList.DataKeys[gvr.RowIndex].Value));
                      // mb= new ModelBuilder(Convert.ToInt32(gvModelList.DataKeys[gvr.RowIndex].Value));
                      // mb.CreateModel();

                    
                }
            }
            
            int period = (txtReadingPeriod.Text == "") ? 14 : int.Parse(txtReadingPeriod.Text);

            if (txtReading.Text != "")
            {
                dataAccess.InsertOrUpdateReading((int)Session["PatientID"], Convert.ToSingle(txtReading.Text), period);
                
            }
            for (int i = 0; i < modelList.Count; i++)
            {
                
                mb.UpdateModel((int)modelList[i]);
               
            }
            dataAccess.FlagModelToUseInPrediction((int)Session["PatientID"], modelList);

           

        }
        protected void gvModelList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Attributes["onmouseover"] = "this.style.cursor='hand';this.style.textDecoration='underline';";
                e.Row.Attributes["onmouseout"] = "this.style.textDecoration='none';";

                e.Row.Attributes["onclick"] = ClientScript.GetPostBackClientHyperlink(gvModelList, "Select$" + e.Row.RowIndex);
            }


        }

        protected void gvModelList_SelectedIndexChanged(object sender, EventArgs e)
        {
            //ObjectDataSource2.SelectParameters[0] = Convert.ToInt32(e.Row.Cells[0].Text);

            //ObjectDataSource2.DataBind();
            gdvAttributeList.DataBind();

        }

        
        protected DataTable CreateDataTableDefinition()
        {
            DataTable dtResult = new DataTable();
            DataColumn myDataColumn;


            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.String");
            myDataColumn.ColumnName = "ModelName";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day1";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day2";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day3";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day4";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day5";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day6";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.Single");
            myDataColumn.ColumnName = "Day7";
            dtResult.Columns.Add(myDataColumn);

            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.String");
            myDataColumn.ColumnName = "Prediction";
            dtResult.Columns.Add(myDataColumn);

            return dtResult;
        }

        protected void btnMakePrediction_Click(object sender, EventArgs e)
        {
            string result = "";
            float[] patternList = new float[7];
            //ArrayList modelList = new ArrayList();
            Dictionary<int, string> modelList = new Dictionary<int, string>();
            DataTable dtResult = CreateDataTableDefinition();






            //create table definition
            //for each prediction that comes back addd row
            //bind the data table to the grid and make grid visible

            foreach (GridViewRow gvr in gvModelList.Rows)
            {
                CheckBox ckBox = (CheckBox)gvr.FindControl("ModelCheckBox");
                if (ckBox.Checked)
                {
                    modelList.Add(Convert.ToInt32(gvModelList.DataKeys[gvr.RowIndex].Value), gvModelList.Rows[gvr.RowIndex].Cells[1].Text );
                    // mb= new ModelBuilder(Convert.ToInt32(gvModelList.DataKeys[gvr.RowIndex].Value));
                    // mb.CreateModel();


                }
            }
            PredictionBuilder pb;
            if (txtDay1.Text != "")
            {
                patternList[0] = Convert.ToSingle(txtDay1.Text);
                if (txtDay2.Text != "")
                {
                    patternList[1] = Convert.ToSingle(txtDay2.Text);
                    if (txtDay3.Text != "")
                    {
                        patternList[2] = Convert.ToSingle(txtDay3.Text);
                        if (txtDay4.Text != "")
                        {
                            patternList[3] = Convert.ToSingle(txtDay4.Text);
                            if (txtDay5.Text != "")
                            {
                                patternList[4] = Convert.ToSingle(txtDay5.Text);
                                if (txtDay6.Text != "")
                                {
                                    patternList[5] = Convert.ToSingle(txtDay6.Text);
                                    if (txtDay7.Text != "")
                                    {
                                        patternList[6] = Convert.ToSingle(txtDay7.Text);
                                    }
                                }
                            }
                        }
                    }
                }
                 foreach (KeyValuePair<int, string> model in modelList )
                {
                    pb = new PredictionBuilder();
                    result = pb.GetPrediction(model.Key , patternList, int.Parse(txtReadingPeriod.Text));
                    DataRow dr = dtResult.NewRow();
                    dr[0] = model.Value;
                     for(int i=0; i<patternList.Length ;i++)
                     {
                         if(patternList[i]>0.0)
                                dr[i+1]=patternList[i];
                         else
                             break;
                     }
                     dr[8] = result;
                     dtResult.Rows.Add(dr);
                }
            }
            else
            {
                
                for (float dose = 0; dose <= 15; dose+=0.5f)
                {
                    //Dictionary<float, string> result = new Dictionary<float, string>();
                    patternList[0] = dose;
                    foreach (KeyValuePair<int, string> model in modelList)
                    {
                        DataRow dr = dtResult.NewRow();
                        pb = new PredictionBuilder();
                        result = pb.GetPrediction(model.Key, patternList, int.Parse(txtReadingPeriod.Text));
                        dr[0] = model.Value;
                        dr[1] = dose;
                        dr[8] = result;
                        dtResult.Rows.Add(dr);
                    }



                    
                   
                }


            }
            dtResult.Select("", "ModelName");
            GridViewBind(dtResult);


           // PredictionBuilder pb = new PredictionBuilder(modelList,int.Parse(txtReadingPeriod.Text));
            

        }

        protected void GridViewBind(DataTable  result)
        {
            gvResult.DataSource = result;
            gvResult.DataBind();

        }
    }
}
